#ifndef __deviants__
#define __deviants__

#include "deviants_include.h"

#include <string.h>
#include <stdio.h>
#include <netdb.h>
#include <time.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <sys/isa_defs.h>

typedef float STDARG_REAL ;

typedef struct Std_statvfs {
     unsigned long f_bsize;   /* preferred file system block size */
     unsigned long f_frsize;  /* fundamental filesystem block (size if supported) */
     unsigned long  f_blocks;  /* total # of blocks on file system in units of f_frsize */
     unsigned long  f_bfree;   /* total # of free blocks */
     unsigned long  f_bavail;  /* # of free blocks avail to non-super-user */
     unsigned long  f_files;   /* total # of file nodes (inodes) */
     unsigned long  f_ffree;   /* total # of free file nodes */
     unsigned long  f_favail;  /* # of inodes avail to non-super-user*/
     unsigned long f_fsid;    /* file system id (dev for now) */
} Std_statvfs ;

#define CTIME_R(t,b) 	ctime_r((t),(b), sizeof(b))


#ifdef _BIG_ENDIAN
#define WORDS_BIGENDIAN 1
#endif


#define MAX_IPS 32
#define now std_now


#ifdef  __cplusplus
extern "C" {
#endif

extern void btsort (void *bot, size_t nmemb, size_t size, void *pvt, int (*compar) (void *, const void *, const void *)) ;

extern char * getTZ ( void );
extern void setTZ() ;

extern double htond ( double val );
extern double ntohd ( double val );
extern void htondp ( double * valp_from, double * valp_to );
extern void ntohdp ( double * valp_from, double * valp_to );
extern float htonf ( float val );
extern float ntohf ( float val );
extern void htonfp ( float * valp_from, float * valp_to );
extern void ntohfp ( float * valp_from, float * valp_to );

extern void swap2 ( void *from, void *to, int n );
extern void swap4 ( void *from, void *to, int n );
extern void swap8 ( void *from, void *to, int n );
extern void N32H4 ( int *to, char *from, int n );
extern void H42N3 ( char *to, int *from, int n );
extern void NF2HD ( double *to, char *from, int n );
extern void HD2NF ( char *to, double *from, int n );
extern void HI2NC ( char *to, int *from, int n );
extern void HI2NS ( char *to, int *from, int n );
extern void NC2HI ( int *to, char *from, int n );
extern void NS2HI ( int *to, char *from, int n );
extern void HI2NF ( char *to, int *from, int n );
extern void NF2HI ( int *to, char *from, int n );

#define DLUNIT  3
#define init_Dlclock() _init_Dlclock(DLUNIT)
extern void _init_Dlclock(int unit)  ;
extern void set_Dlclock(double time) ; 

extern double std_now ( void );
extern double now_ ( void );

extern int is_nfs ( char *path );

extern void * nomem ( void *a, int n );

extern int std_set_timer ( void (*alarm_handler)(void), double how_long );

extern int my_hostname ( char *name );
extern int my_os ( char *name );
extern int my_hardware ( char *name );
extern int my_ip ( char *hostname, char *ipc, int *ip );
extern int ip2name ( int addr, char *name );
extern int my_username ( char *name );

extern int name2ip ( char *name, struct in_addr *addr, char *ipc );

extern char *mcinfo (char **);
extern int my_ips ( char *ips, int size );
extern int my_ipv6s ( struct sockaddr_storage *sa, int size );
extern int my_ether (char *info) ;

extern void reserve_FILE(void) ;
extern void release_FILE(void) ;

extern int gxpipe ( char *cmd, char **env, int *cmdin );
extern int gxpipex ( char *cmd, int *cmdin );
extern int gxopen ( char *filename );
extern int gxline ( int fd, char *aline, int maxchars );
extern int gxtell ( int fd );
extern int gxseek ( int fd, int p );
extern int gxclose ( int fd );

extern int std_statvfs(const char *path, Std_statvfs *buf);

extern int pid_exists ( int pid );
extern int is_timezone ( char *name );

extern void * std_dlopen ( const char *lib );

extern void show_stack_trace ( void );
extern void show_fault ( int sig, siginfo_t *vsi, void *vuap );

#ifdef  __cplusplus
}
#endif

#endif
